--- old-enc-unicode.lisp	2011-10-13 18:04:11 +0400
+++ enc-unicode.lisp	2011-10-27 17:21:51 +0400
@@ -699,11 +699,14 @@
     (labels ((make-bom-check-form (end start getter src)
                (if (null endianness)
                  ``(when (not (zerop (- ,,end ,,start)))
-                     (case (,,getter ,,src 0 ,',bytes :ne)
+                     (case (,,getter ,,src ,,start ,',bytes :ne)
                        (#.+byte-order-mark-code+
                          (incf ,,start ,',bytes) nil)
-                       (#.+swapped-byte-order-mark-code-32+
-                        (incf ,,start ,',bytes) T)
+                       ,,(ecase bytes
+                            (2 ``(#.+swapped-byte-order-mark-code+
+                                   (incf ,,start 2) T))
+                            (4 ``(#.+swapped-byte-order-mark-code-32+
+                                  (incf ,,start 4) T)))
                        (T #+little-endian T)))
                  '()))
              (make-setter-form (setter code dest di)
